#include "MainWindow.h"
#include <unistd.h>
#include <iostream>
#include <sstream>
#include <stdexcept>
#include <QApplication>
#include <QScopedPointer>

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    QScopedPointer<QApplication> app;

    try {

        /* Create the Qt application. */
        app.reset(new QApplication(argc, argv));

        /* Set the locale for the C runtime. */
        if (!setlocale(LC_ALL, "")) {
            ostringstream msg;
            msg << "setlocale: " << strerror(errno);
            throw runtime_error(msg.str());
        }

        /* Show the main window. */
        Harbinger::MainWindow mainWindow;
        mainWindow.show();

        /* Enter the main event loop. */
        app->exec();

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 0;
    }

    return rv;
}
